{ Gestion du mode VGA 320x200 en 256 couleurs }
Unit FVGA256;

interface

type
	TRGB=array[0..2] of byte;
	TPalette=array[0..255] of TRGB;

procedure initgraph;
procedure textmode;
procedure plot(x,y,c:integer);
procedure SetPal(var Pal:Tpalette);
procedure ScrollRight(n:integer);
procedure ScrollUp(n:integer);
procedure SetPalMono;

implementation

const
	XSIZE=320;
	YSIZE=200;

procedure SetPalMono;
var p:Tpalette;
    i:integer;
begin
     for i:=0 to 255 do begin
         p[i,0]:=i shr 2;
         p[i,1]:=i shr 2;
         p[i,1]:=i shr 2;
     end;
     setpal(p);
end;


procedure initgraph; assembler;
asm
	mov ax,13h
	int 10h
end;

procedure textmode; assembler;
asm
	mov ax,3h
	int 10h
end;

procedure plot(x,y,c:integer); assembler;
asm
	mov ax,y
	mov cx,320
	mul cx
     add ax,x
	mov di,ax
	mov ax,0A000h
	mov es,ax
	mov ax,c
	or ah,ah
	je @1
	xor es:[di],al
	jmp @2
@1:
	mov es:[di],al
@2:
end;

procedure SetPal(var Pal:Tpalette); assembler;
asm
	mov ax,1012h
	mov bx,0
	mov cx,256
	les dx,pal
	int 10h
end;

procedure ScrollRight(n:integer); assembler;
asm
	push ds
	pushf
	mov ax,0A000h
	mov es,ax
	mov ds,ax
     mov cx,YSIZE
	mov bx,n
	mov dx,XSIZE
	or bx,bx
	je @fin
	jg @2
	neg bx
	sub dx,bx
	mov si,bx
	xor di,di
	cld
	jmp @1
@2:
	sub dx,bx
	mov si,dx
	dec si
	mov di,XSIZE-1
	std
@1:
	push si
	push di
	push cx
	mov cx,dx
     rep movsb
	pop cx
	pop di
	pop si
	add si,XSIZE
	add di,XSIZE
	loop @1
@fin:
	popf
	pop ds
end;

procedure ScrollUp(n:integer); assembler;
asm
	push ds
	pushf
	mov ax,0A000h
	mov es,ax
	mov ds,ax
	mov bx,n
	or bx,bx
	je @fin
	jg @2
	neg bx
	mov si,XSIZE*YSIZE-2
	mov di,si
	mov ax,XSIZE
	mul bx
	sub si,ax
	mov cx,XSIZE*YSIZE
	sub cx,ax
     shr cx,1
	std
	jmp @1
@2:
	xor di,di
	mov ax,XSIZE
	mul bx
     mov si,ax
	mov cx,XSIZE*YSIZE
	sub cx,ax
	shr cx,1
	cld
@1:
	rep movsw
@fin:
	popf
	pop ds
end;



end.